float m = 1.0, n = 1.0;
//#b0f2bc,#89e8ac,#67dba5,#4cc8a3,#38b2a3,#2c98a0,#257d98
//#ffc6c4,#f4a3a8,#e38191,#cc607d,#ad466c,#8b3058,#672044
//#fde0c5,#facba6,#f8b58b,#f59e72,#f2855d,#ef6a4c,#eb4a40
//#d1eeea,#a8dbd9,#85c4c9,#68abb8,#4f90a6,#3b738f,#2a5674
//#f3e0f7,#e4c7f1,#d1afe8,#b998dd,#9f82ce,#826dba,#63589f
color[] colorsCases = {#4cc8a3,#cc607d,#f59e72,#b998dd,#68abb8};
color[] colorDeaths = {#b0f2bc,#ffc6c4,#fde0c5,#f3e0f7,#d1eeea};

boolean[] state = {true, true, true, true, true};
boolean[] year = {true, true, true};

void drawTotalCases() {
    for (int i = 0; i < 15; i++) {
        if (state[i % 5] && year[i / 5]) {
            ArrayList<Case> datas = total.get(i);
            drawCases(datas, i % 5, i / 5);
            drawCasesHover(datas, i % 5);
            drawDeaths(datas, i % 5);
            drawDeathHover(datas, i % 5);
        }
    }
    
}


void drawCasesHover(ArrayList<Case> datas, int k) {
    pushMatrix();
    if(year[0] == true && year[1] == true && year[2] == true) translate(0, 0, datas.get(0).z);
    for (int i = 0; i < datas.size(); i++) {
        Case cur = datas.get(i);
        fill(255);
        stroke(100);
        point(cur.caseX, cur.caseY, cur.caseZ * m);
        float mouseObjectDistance = sq(mouseX - screenX(cur.caseX, cur.caseY, cur.caseZ * m)) + sq(mouseY - screenY(cur.caseX, cur.caseY, cur.caseZ * m));
        if (mouseObjectDistance < 20) {
            // // adda bigger point
            // stroke(20);
            // point(cur.caseX, cur.caseY, cur.caseZ * m);
            // fill(255);
            // addtext label
            textMode(SHAPE);
            textSize(30);
            pushMatrix();
            float[] rotations = cam.getRotations();
            ////rotateX(rotations[0]);
            ////rotateY(-rotations[1]);
            // rotateZ(rotations[2]);
            text(cur.year + "-" + cur.month + "-" + cur.day + "\n" + cur.newCases + "\n",cur.caseX, cur.caseY, cur.caseZ * m);
            popMatrix();
        }
    }
    popMatrix();  
}

void drawDeathHover(ArrayList<Case> datas, int k) {
    pushMatrix();
    if(year[0] == true && year[1] == true && year[2] == true) translate(0, 0, datas.get(0).z);
    for (int i = 0; i < datas.size(); i++) {
        Case cur = datas.get(i);
        fill(255);
        stroke(100);
        point(cur.caseX, cur.caseY, cur.deathZ * m);
        float mouseObjectDistance = sq(mouseX - screenX(cur.caseX, cur.caseY, cur.deathZ * m)) + sq(mouseY - screenY(cur.caseX, cur.caseY, cur.deathZ * m));
        if (mouseObjectDistance < 20) {
            // adda bigger point
            // stroke(20);
            // point(cur.caseX, cur.caseY, cur.deathZ * m);
            // fill(255);
            // addtext label
            textMode(SHAPE);
            textSize(30);
            pushMatrix();
            float[] rotations = cam.getRotations();
             textAlign(RIGHT);
            // rotateX(-rotations[0]);
            // ////rotateY(-rotations[1]);
            // rotateZ(-rotations[2]);
            text(cur.year + "-" + cur.month + "-" + cur.day + "\n" + cur.newDeaths + "\n ",cur.caseX , cur.caseY, cur.deathZ * m);
            popMatrix();
        }
    }
    popMatrix();  
}

void drawCases(ArrayList<Case> datas, int k, int yearMax) {
    //drawaxis(yearMax);
    noStroke();
    fill(colorsCases[k]);
    pushMatrix();
    if(year[0] == true && year[1] == true && year[2] == true) translate(0, 0, datas.get(0).z);
    for (int i = 0; i < datas.size(); i++) {
        beginShape(TRIANGLES);
        //beginShape();
        Case cur = datas.get(i);
        Case next;
        if (i + 1 == datas.size()) { 
            next = datas.get(0); 
        } else {    
            next = datas.get(i + 1);    
        }    
        vertex(cur.x, cur.y, 0); 
        vertex(cur.caseX, cur.caseY, cur.caseZ * m);    
        vertex(next.x, next.y, 0);    
        endShape();   
    }
    popMatrix();  
}

void drawDeaths(ArrayList<Case> datas, int k) {
    noStroke(); 
    fill(colorDeaths[k]); 
    pushMatrix();
   if(year[0] == true && year[1] == true && year[2] == true)  translate(0, 0, datas.get(0).z);
    for (int i = 0; i < datas.size(); i++) {
        beginShape(TRIANGLES);   
        Case cur = datas.get(i);   
        Case next;
        if (i + 1 == datas.size()) {
            next = datas.get(0);
        } else {
            next = datas.get(i + 1);
        }
        vertex(cur.x, cur.y, 0);
        vertex(cur.caseX, cur.caseY,cur.deathZ * n);
        vertex(next.x, next.y,0);
        endShape();
    }
    popMatrix();  
}

void drawaxis(int k) {
    stroke(255);
    strokeWeight(1);
    line(0, 0, k * 800, 0, 0,(k  * 800 + (float)Math.sqrt(maxCases[k])) * m);
    stroke(255,0,0);
    strokeWeight(10);
    point(0, 0,(k  * 800 + (float)Math.sqrt(maxCases[k])) * m);
}

void legend() {
    textAlign(LEFT);
    hint(DISABLE_DEPTH_TEST);    
    cam.beginHUD();
    scaleW = (float) width / 1280;
    println("distance:" + distance);
    scaleH = height / 720.0;
    println("scaleW:" + scaleW);
    println("scaleH:" + scaleH);
    // define the colors and texts for the legend
    String[] texts = {"USA Daily Cases", "RU Daily Cases", "CN Daily Cases", "FR Daily Cases", "GB Daily Cases",
  "USA Daily Deaths", "RU Daily Deaths", "CN Daily Deaths", "FR Daily Deaths", "GB Daily Deaths"};
    
    //set the size and position of the legend
    int rectSize = 20;  // size of the colored rectangles
    pushMatrix();
    // translate(- scaleW * width, height / 2 / scaleH);
    translate(10,height * (0.55 + (scaleH - 1) * 0.2) ,0);
    
    //draw the colored rectangles and text in the legend
    for (int i = 0; i < colorsCases.length; i++) {
        fill(colorsCases[i]);
        noStroke();
        rect(0, i * 30, rectSize, rectSize);
        fill(255);
        textSize(20);
        text(texts[i], 30, 15 + i * 30);
    }
    for (int i = 0; i < colorDeaths.length; i++) {
        fill(colorDeaths[i]);
        noStroke();
        rect(0,(i + 5) * 30, rectSize, rectSize);
        fill(255);
        textSize(20);
        text(texts[i+5], 30,  15 + (i + 5) * 30);
    }
    popMatrix();
    
    //title
    pushMatrix();
    translate(20 * scaleW, 50 * scaleH,0);
    println("height:" + height);
    strokeWeight(10);
    stroke(255);
    text("MAT259 Project 3\n COVID-19 Pandemic Trends in the UN's \n Five Permanent Members (2020-2022)\n Zeyu Wang",0,0);
    popMatrix();
    
    //interaction guide
    pushMatrix();
    //translate(width*0.78 * 1.1,height * (0.47 + (scaleH - 1) * 0.2),0);
    translate(width * (scaleW - 0.5 * (scaleW - 1)/0.5) * 0.8, height * (0.47 + (scaleH - 1) * 0.2),0);
    strokeWeight(10);
    stroke(255);
    strokeWeight(1);
    text("Interaction Mode:\n 1- United States of America\n 2- Russian Federation \n 3- China\n 4- The United Kingdom \n 5- France \n z- Data in 2020 \n o- Data in 2021 \n t- Data in 2022\n a- Data in all 3 years \n UP & DOWN- Wave cases \n RIGHT&LEFT- Wave deaths",0,0);
    popMatrix();
    cam.endHUD();
    hint(ENABLE_DEPTH_TEST);
}
